// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice-E is licensed to you under the terms described in the
// ICEE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice-E version 1.2.0
// Generated from file `Router.ice'

#ifndef __IceE_Router_h__
#define __IceE_Router_h__

#include <IceE/ProxyF.h>
#ifndef ICEE_PURE_CLIENT
#  include <IceE/ObjectF.h>
#endif
#include <IceE/Exception.h>
#include <IceE/ScopedArray.h>
#include <IceE/Proxy.h>
#ifndef ICEE_PURE_CLIENT
#  include <IceE/Object.h>
#  include <IceE/Incoming.h>
#endif
#include <IceE/Outgoing.h>
#include <IceE/BuiltinSequences.h>
#include <IceE/UndefSysMacros.h>

#ifndef ICEE_IGNORE_VERSION
#   if ICEE_INT_VERSION / 100 != 102
#       error IceE version mismatch!
#   endif
#   if ICEE_INT_VERSION % 100 < 0
#       error IceE patch level mismatch!
#   endif
#endif

#ifndef ICE_API
#   ifdef ICE_API_EXPORTS
#       define ICE_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Ice
{

class Router;

}

}

namespace Ice
{

#ifndef ICEE_PURE_CLIENT

class Router;
ICE_API bool operator==(const Router&, const Router&);
ICE_API bool operator<(const Router&, const Router&);

#endif // ICEE_PURE_CLIENT

}

namespace IceInternal
{

#ifndef ICEE_PURE_CLIENT
ICE_API ::Ice::Object* upCast(::Ice::Router*);
#endif // ICEE_PURE_CLIENT
ICE_API ::IceProxy::Ice::Object* upCast(::IceProxy::Ice::Router*);

}

namespace Ice
{

#ifndef ICEE_PURE_CLIENT

typedef ::IceInternal::Handle< ::Ice::Router> RouterPtr;

#endif // ICEE_PURE_CLIENT

typedef ::IceInternal::ProxyHandle< ::IceProxy::Ice::Router> RouterPrx;

ICE_API void __read(::IceInternal::BasicStream*, RouterPrx&);

}

namespace Ice
{

}

namespace Ice
{

#ifndef ICEE_PURE_CLIENT

class ICE_API Router : virtual public ::Ice::Object
{
public:

    typedef RouterPrx ProxyType;
    typedef RouterPtr PointerType;
    

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Ice::ObjectPrx getClientProxy(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getClientProxy(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ObjectPrx getServerProxy(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerProxy(::IceInternal::Incoming&, const ::Ice::Current&) const;

    ICE_DEPRECATED_API virtual void addProxy(const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addProxy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::ObjectProxySeq addProxies(const ::Ice::ObjectProxySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addProxies(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);
};

#endif // ICEE_PURE_CLIENT

}

namespace IceProxy
{

namespace Ice
{

class Router : virtual public ::IceProxy::Ice::Object
{
public:

    ::Ice::ObjectPrx getClientProxy()
    {
        return getClientProxy(0);
    }
    ::Ice::ObjectPrx getClientProxy(const ::Ice::Context& __ctx)
    {
        return getClientProxy(&__ctx);
    }
    
private:

    ICE_API ::Ice::ObjectPrx getClientProxy(const ::Ice::Context*);
    
public:

    ::Ice::ObjectPrx getServerProxy()
    {
        return getServerProxy(0);
    }
    ::Ice::ObjectPrx getServerProxy(const ::Ice::Context& __ctx)
    {
        return getServerProxy(&__ctx);
    }
    
private:

    ICE_API ::Ice::ObjectPrx getServerProxy(const ::Ice::Context*);
    
public:

    ICE_DEPRECATED_API void addProxy(const ::Ice::ObjectPrx& proxy)
    {
        addProxy(proxy, 0);
    }
    ICE_DEPRECATED_API void addProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
    {
        addProxy(proxy, &__ctx);
    }
    
private:

    ICE_API void addProxy(const ::Ice::ObjectPrx&, const ::Ice::Context*);
    
public:

    ::Ice::ObjectProxySeq addProxies(const ::Ice::ObjectProxySeq& proxies)
    {
        return addProxies(proxies, 0);
    }
    ::Ice::ObjectProxySeq addProxies(const ::Ice::ObjectProxySeq& proxies, const ::Ice::Context& __ctx)
    {
        return addProxies(proxies, &__ctx);
    }
    
private:

    ICE_API ::Ice::ObjectProxySeq addProxies(const ::Ice::ObjectProxySeq&, const ::Ice::Context*);
    
public:
    
    ICE_API static const ::std::string& ice_staticId();
};

}

}

#endif
